{{
Dynamic Object Loader
 by Steven Messenger

Thanks to
Hippy (AiChip), Cliff L. Baffle, and the author of Gear for their documentation of Spin
and the spin object format. This program would not be possible without their efforts.

Peter Verkaik, for allowing me to use his excellent heap object.

Chip and the others at Parallax for creating such a great product.

Everyone on the forums for creating such a great environment.



V_001 - scrapped modifyObject method (also callObjectHelper), it is easier (and smaller) to achieve this by using a
        dummy object (suggested by hippy)
      - don't know if the VAR links are working yet, but it is loading and calling the object

V_002 - trying to make DYN_VGA_Text_Demo to work
      - bug fix - dummyStart was set to the wrong value so we actually calling the dummy object and
                  not the test object
      - this version will run DYN_VGA_Text_Demo (a modified of Chips VGA_Text_Demo) if lines
        135 and 136 are commented out. this is getting there but still not all that useful.
        something seems to be going wrong while I am moving the object to it's new address. (it
        doesn't even work if I just copy it to the same location)
        this version will correctly run testObj though, even if it is moved. so there is some
        weird bug that I have to find and fix.

V_003 - fixed several bugs with the pointer addresses
      - now we can actually move the object to an address in memory and properly methods in it
      - If you run this hooked up to a vga display, it should display
        acalled methodRunner!!!
        address6000

      - VAR is still in the orignal location, but I think that will be fairly easy to move now
        if I can stop making stupid mistakes

V_004 - Now we are moving the VAR block and it still works.

V_005 - Implemented modification of loaded object so that it can call other objects.
      - Tested it on a propeller and it works :-)

V_006 - Added Peter Verkaik's heap manager for storing objects in
      - Decided not to change to longs as it looks hard. Especially now that I am using the heap.
      - For some weird reason, the return in line 168 of "heap" was not working so I had to replace
        it with abort.
      - Added constants for init, run, stop and link back to DOL
        
V_007 - Fixed load object so that it can load more than one object
      - Partly implemented unloadObject. Not tested yet.
      - Currently Busted

V_008 - Started with V_006 again
      - Think problem with V_007 was that the heap got non-long aligned and
        so the methods we copied in were not long-aligned and so would not word
      - Implemented loading of multiple objects
      - Changed loadObject so that we no longer need the number of methods in
        the object that we are loading
      - Fixed bug, loadObject now allocates enough space for the object and its
        variables
      - Problem with the heap not returning was Gear. Changed the abort back to return.
      - Fixed TV_Text_Demo to work with DOL
      - This one loads TV_Text_Demo, TV_Text_Demo loads VGA_Text_Demo and calls a method
        in it and then TV_Text_Demo gets unloaded.
      - Implemented unloadObject
      - Added a whole heap of constants for call things
      - Starting to implement some abort values
      - No longer need an extra file to load an object. Everything can be determined
        from the object header.
      
        




It (will eventually) dynamically loads objects from an SD card and allows inter-object communication.

Objects that wish to be loaded must follow the example of testObj.spin and have an additional file
on the SD card with the same file name that specifies the objectName, length of the object and the number of
elements in the object.

Objects to be loaded can include sub objects.

objectName is a long that is used at run-time to determine which object to call
it cannot be 0 or a couple of other values yet to be determined

the number of elements in the object is the sum of the number of PUB methods in the top object,
the number of PRI methods in the top object and the number of direct sub-objects

}}
CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  LENGTH = $6000  'when done, this can be set the the actual value and it will us more room
  'NumPUB = 6          'not needed any longer since I am using endOfObjects instead
  'NumPRI = 0
  'NumSUB = 2
  'ThisNumElements = NumPUB+NumPRI+NumSUB
  StackSize = $512 'amount of space to reserve for stack
  HeapSize = 4096*4

  'Names for methods
  #0
  init          'Called while loading an object to determine where to modify the object
  run           'DOL equivalent of start
  stop          'Called when an object is being unloaded. It should free any memory,
                'release any locks and stop any cogs started.

  'Names for DOL methods
  #0
  DOLload       'Load another object
                'arg: pointer to the name of the object (long) plus the filename (string)
                'returns: 
  DOLunload     'Unload an object
                'arg: name of the object to unload
                'returns:
  DOLgetStart   'Get the start address of an object
                'arg: name of object
                'returns: the start address of an object
  DOLgetLength  'Get the length of an object (Program + VAR)
                'arg: name of object
                'returns: length of Program + VAR of object 

  'object number for DOL
  DOL=0

  'abort values
  #0
  AbortNotEnoughMemory
  AbortCouldNotFindObject
  AbortCouldNotFindMethod
  AbortTooManyObjects
  
  
OBJ
  'fsrw : "SD object"  'use new version from Mike Green for multiple files open when available
                       'may even be able to use dynamic loading so that we can have as many
                       'files open as memory allows.
  'testObj : "testObj"
  heap : "heap"
  testObjVGA : "DYN_VGA_Text_Demo"
  testObjTV : "DYN_TV_Text_Demo"
  dummyObject : "dummyObject"
  
VAR
  long objectNameList[16]    
  word objectStartPtr[16]    'holds the offset, not the actual address
  word objectLength[16]
  word objectVARBase[16]     'holds the offset, not the actual address
  word objectAllocated

  word programStart  'a pointer that holds the start point of this object
  word varStart      'a pointer that points to the start of this objects var region
  word dummyStart    'a pointer that points to the pointer to dummyObject
  word wordDummyStart 

  long heapArray[HeapSize/4]  'something to store our objects in
          'changed this froma byte array to a long array
          'this was probably the problem with V_006

DAT
endOfObjects long 0
  
PUB start|temp
{{
  loads "kernal.bin" from the SD card and runs the object in it
}}
  'read programStart and varStart from header and calculate dummyStart
  programStart:=word[6]
  varStart:=word[8]
  dummyStart:=@endOfObjects-4
  wordDummyStart:=word[dummyStart]

  'create our heap
  heap.create(@heapArray,HeapSize)
    
  'load an object from the SD card and run it
  loadObject(1)
  callObject(1,run,1)
  callObject(1,3,$A)
  callObject(1,3,$AB)
  waitCNT(CNT)
  unloadObject(1)

PUB callObject(objectName,methodName,arg)|i
{{
  calls the selector method in objectName with methodName and arg
  allows calling of dynamically loaded objects and inter-object communication  
}}
  if objectName==DOL
    case methodName
      DOLload:
        return loadObject(arg)
      DOLunload:
        return unloadObject(arg)
      DOLgetStart:
        return getStartObject(arg)
      DOLgetLength:
        return getLengthObject(arg)
    return objectLength[0]
    
  repeat i from 0 to 16
    if objectNameList[i]==objectName
      word[dummyStart]:=objectStartPtr[i]-programStart
      word[dummyStart+2]:=objectVARBase[i] 
      return dummyObject.something(methodName,arg)

  abort AbortCouldNotFindObject
        'what value to return? maybe use some set location in the DAT section?
        'maybe put in a pointer when loading the object?

PUB loadObject(stringPtr)|testObjStart,i,temp,VARSize,l
{{
  loads an object from the SD card into some free memory
}}
  'how about we replace the *.DOL file with a couple of set calls
  'would save having another file
  
  'open *.DOL file
  'read objectName   'comes from loading object
  'read length       'read ProgramStart, VARStart and StackStart from header
                     'these will give us all the lengths we need
  'read num objects  'no longer needed since object to be loaded does this
  'close *.DOL file

  'find first unused object space with enough space
  'set that space to used in objectAllocated
  'set objectName - from *.DOL
  'set objectStartPtr - first space that is large enough from above. May be able to use a heap object.
  'set objectSize - from *.DOL
  
  'open *.bin
  'set objectVARBase - from objcet header   
  'load *.bin minus header into unused space
  'close *.bin

  'modify function in just loaded object so that it can call this object and therefore
  'every other object

  ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
  'for testing purposes. moves an object and pretends that it has been loaded from an SD card
  'for this just use any space and allocate the first space
  repeat i from 0 to 15
    if (objectAllocated&(1<<i))==0
      quit

  if i==15
    abort AbortTooManyObjects

  objectAllocated:=objectAllocated|(1<<i)

  'set object name
  objectNameList[i]:=stringPtr
  
  'find the start of testObj
  if stringPtr==1
    testObjStart:=word[dummyStart-4]+programStart
  else
    testObjStart:=word[dummyStart-8]+programStart
  
  'set objectSize
  if stringPtr==1
    objectLength[i]:=wordDummyStart+programStart-testObjStart
  else
    objectLength[i]:=word[dummyStart-4]+programStart-testObjStart

  'set the VAR size
  if stringPtr==1
    VARSize:=296*4
  else
    VARSize:=283*4

  'get some space from the heap to store our object in
  objectStartPtr[i]:=heap.allocate(objectLength[i]+VARSize)

  if objectStartPtr[i]==0
    abort AbortNotEnoughMemory
     
  'move testObj to where we want it
  'just making sure that it is past the end of the stack
  repeat l from 0 to objectLength[i]
    byte[objectStartPtr[i]+l]:=byte[testObjStart+l]

  'set objectVARBase
  objectVARBase[i]:=objectStartPtr[i]-programStart+objectLength[i]

  'set the orignal to 0 so that we will know if we go to it
  repeat l from 0 to objectLength[i]
    byte[testObjStart+l]:=0

  'call the object to initilize itself so that it can call this object
  word[dummyStart]:=objectStartPtr[i]-programStart 'set the program offset
  word[dummyStart+2]:=objectVARBase[i]             'set the VAR offset
  temp.word[0]:=-(objectStartPtr[i]-programStart)  'offset back to DOL
  temp.word[1]:=-objectVARBase[i] 
  dummyObject.something(init,temp)                 'call the object
  objectLength[i]:=objectLength[i]+VARSize         'fix up the length
  
PUB unloadObject(objectName)|i,l
{{
  Unloads an object. calls the "stop" method in the object, removes object from all lists and
  sets the memory where it was located to 0
}}
  repeat i from 0 to 15
    if objectNameList[i]==objectName
      word[dummyStart]:=objectStartPtr[i]-programStart
      word[dummyStart+2]:=objectVARBase[i]
      dummyObject.something(stop,0)
      repeat l from 0 to objectLength[i]
        byte[objectStartPtr[i]+l]:=0
      heap.free(objectStartPtr[i])
      objectStartPtr[i]:=0
      objectName[i]:=0
      objectLength[i]:=0
      objectVARBase[i]:=0
      objectAllocated:=objectAllocated&(!(1<<i))

  abort AbortCouldNotFindObject


PUB getStartObject(objectName)|i
  repeat i from 0 to 15
    if objectNameList[i]==objectName
      return objectStartPtr[i]
  abort AbortCouldNotFindObject

PUB getLengthObject(objectName)|i
  repeat i from 0 to 15
    if objectNameList[i]==objectName
      return objectLength[i]
  abort AbortCouldNotFindObject
 